/*
    cve-manager : CVE management tool
    Copyright (C) 2017-2022 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include    "data_preproc_common.h"

//-----------------------------------------------------------------------------
// Form error message

string ErrMsg(const string &msg, const exception &exc){

    const string err_det = exc.what();
    const string err_msg = msg + (!err_det.empty() ? " (" + err_det + ")" : "");

    return err_msg;
    }

//-----------------------------------------------------------------------------
// Get a vul identifier in a form of a VulId struct from a given tree entry

pair<VulId, bool> GetVulId(const tree::TSelectedDataEntry &entry){

    VulId vul_id;
    bool ok = true;

    try{
        const auto &vul_id_str = entry.at(VUL_ID).front();
        vul_id.y.push_back(vul_id_str.substr(4, 4));
        vul_id.n.push_back(vul_id_str.substr(9));
        }
    catch(const out_of_range& e){
        ok = false;
        cout << e.what() << endl;
        }

    return {vul_id, ok};
    }

//-----------------------------------------------------------------------------
