/*
    cve-manager : CVE management tool
    Copyright (C) 2017-2022 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef     cve_import_data_preproc_commonH
#define     cve_import_data_preproc_commonH

#include    <algorithm>
#include    <regex>

#include    "tree.h"

//-----------------------------------------------------------------------------

const regex whitespace(R"(\s+)");

typedef set<string> TProductNames;
typedef pair<TProductNames, TProductNames> TExclAndExcProductNames;
typedef map<string, TExclAndExcProductNames> TExcludedProducts;

// Vulnerability identifier - a year and a number
struct VulId{
    tree::TSelectedDataEntryItem y;
    tree::TSelectedDataEntryItem n;
    };

// Form error message
string ErrMsg(const string &msg, const exception &exc);
// Get a vul identifier in a form of a VulId struct from a given tree entry
pair<VulId, bool> GetVulId(const tree::TSelectedDataEntry &entry);

//-----------------------------------------------------------------------------

#endif
