/*
    cve-manager : CVE management tool
    Copyright (C) 2017-2022 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef     cve_import_data_preproc_nvdH
#define     cve_import_data_preproc_nvdH

#include    "data_preproc_common.h"

#define     CPE_PART_POS            8
#define     CPE_VENDOR_POS          10
#define     CPE_LINUX_PRODUCT_POS   16
#define     CPE_DELIMITER           ":"

//-----------------------------------------------------------------------------

// Splip CPE name to part, vendor, product and version
bool PreprocessCPEDict(tree::TSelectedData &selected_data,
    const TExcludedProducts &excluded_cpe, string &msg);
// Adjust NVD vulnerabilities data that was selected from a JSON document
bool PreprocessNVDVul(tree::TSelectedData &selected_data,
    const TExcludedProducts &excluded_cpe, string &msg);

//-----------------------------------------------------------------------------

#endif
