/*
    cve-manager : CVE management tool
    Copyright (C) 2017-2022 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef     cve_import_data_preproc_nvd_software_interrelationH
#define     cve_import_data_preproc_nvd_software_interrelationH

#include    "tree.h"

#ifdef      DATA_PREPROCESS_DEBUGGING
#include    "libcontrol++/src/stringify.h"

//-----------------------------------------------------------------------------

void PrintStages(const vector<map<string, set<int>>> &stages,
        const unsigned short indent=0);
void PrintCombination(vector<set<int>> &comb,
        const unsigned short indent=0);
void PrintProcessedCombinations(map<int, set<int>> &comb,
        const unsigned short indent=0);

//-----------------------------------------------------------------------------
#endif

pair<vector<map<string, set<int>>>, bool> FormStagesOfOperations(
    tree::TSelectedDataEntry &entry, size_t software_item_size);

void ProcessConjunction(vector<set<int>> &disjunction_of_conjunctions,
    const set<int> &group, map<int, set<int>> &processed_combinations);

void ProcessDisjunction(vector<set<int>> &disjunction_of_conjunctions,
    const set<int> &group, map<int, set<int>> &processed_combinations);

pair<vector<set<int>>, bool> FormDisjunctionOfConjunctions(
    const vector<map<string, set<int>>> &stages);

void FilterDisjunctionOfConjunctions(
    vector<set<int>> &disjunction_of_conjunctions,
    tree::TSelectedDataEntryItem &software_item);

void ReconstructSoftwareItem(
    vector<set<int>> &disjunction_of_conjunctions,
    tree::TSelectedDataEntryItem &software_item);

//-----------------------------------------------------------------------------

#endif
