/*
    cve-manager : CVE management tool
    Copyright (C) 2017-2022 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef     cve_import_mainH
#define     cve_import_mainH

//#define   CVEIMPORT_DEBUGGING
//#define   DATA_PREPROCESS_DEBUGGING
//#define   FSTEC_VER_CONV_DEBUGGING

#ifdef      CVEIMPORT_DEBUGGING
#include    "libcontrol++/src/libcontrol++.h"
#include    "libcontrol++/src/conf.h"
#include    "libcontrol++/src/print.h"
#include    "libcontrol++/src/text.h"
#include    "libcontrol++/src/vector.h"
#include    "libcontrol++/src/map.h"
#include    "libcontrol++/src/special.h"
#include    "libcontrol++/src/filesystem.h"
#include    "libcontrol++/src/text.h"
#else
#include    <libcontrol++/libcontrol++.h>
#include    <libcontrol++/conf.h>
#include    <libcontrol++/print.h>
#include    <libcontrol++/text.h>
#include    <libcontrol++/vector.h>
#include    <libcontrol++/map.h>
#include    <libcontrol++/special.h>
#include    <libcontrol++/filesystem.h>
#include    <libcontrol++/text.h>
#endif

#include    "libcve-manager/src/manager.h"

#define     GROUPS      CONF_DIR "groups.csv"         // List of package/product groups
#define     CPE_EXCL    CONF_DIR "cpe-excluded.csv"   // List of excluded CPEs
#define     FSTEC_EXCL  CONF_DIR "fstec-excluded.csv" // List of excluded FSTEC products
#define     FSTEC_VUL   "vulxml/export/export.xml"    // FSTEC vulnerabilities list
#define     CPE_DICT    "official-cpe-dictionary_v2.3.xml"  // NVD CPE dict

// Targets of procedures of import
#define     TARGET_FSTEC    "fstec"
#define     TARGET_NVD      "nvd"
#define     TARGET_CPE      "cpe"

#define     VER_LEN         64  // Length of 'ver' MySQL fields
#define     REL_LEN         64  // Length of 'rel' MySQL fields

#define     DEBUG_FLAG      0   // Index of the '--debug' run-mode flag
#define     UPDATE_FLAG     1   // Index of the '--update' run-mode flag

extern TRunMode run_mode;   // Set of run-params of the program
extern TPrinter printer;    // Printer of the complex messages

using namespace std;

#endif
